﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data.Common;
using System.Data.SqlServerCe;

namespace PV178.Lecture8.Demo1
{
    class DbCommand
    {
        public static void Run()
        {
            InsertProduct("Rolls", 2.2m, 231);
            InsertProduct("Bread", 22.90m, 21);

            ListProduct();
        }

        private static void ListProduct()
        {
            using (IDbConnection connection = new SqlCeConnection(@"Data Source=Data\UniversalExportsDatabase.sdf"))
            {
                connection.Open();

                IDbCommand cmd = connection.CreateCommand();
                cmd.CommandText = "SELECT Id, Name,Price,UnitsInStock FROM Products;";
                cmd.CommandType = System.Data.CommandType.Text;

                IDataReader reader = cmd.ExecuteReader();
                while (reader.Read())
                {
                    Console.WriteLine("{0}: {1} Kč, {2} ks skladem", reader["Name"], reader.GetInt16(3), reader.GetDecimal(2));
                }
            }
        }

        private static void InsertProduct(string name, decimal price, int units)
        {
            using (SqlCeConnection connection = new SqlCeConnection(@"Data Source=Data\UniversalExportsDatabase.sdf"))
            {
                connection.Open();

                SqlCeCommand cmd = connection.CreateCommand();
                cmd.CommandText = "INSERT INTO Products (Id, Name, Price, UnitsInStock) VALUES (@id, @name, @price, @units)";
                cmd.CommandType = System.Data.CommandType.Text;

                cmd.Parameters.AddWithValue("id", Guid.NewGuid());
                cmd.Parameters.AddWithValue("name", name);
                cmd.Parameters.AddWithValue("price", price);
                cmd.Parameters.AddWithValue("units", units);

                cmd.ExecuteNonQuery();
            }
        }
    }
}
