﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PV178.Lecture8.Demo1
{
    class InsertDataDemo
    {
        public static void Run()
        {
            using (var db = new UniversalExportsContext(Program.GetConnectionString()))
            {
                InsertData(db);

                ListData(db);
            }
        }

        private static void InsertData(UniversalExportsContext db)
        {
            Product superWatch = new Product
                                     {
                                         Id = Guid.NewGuid(),
                                         Name = "Spy Super Watch",
                                         Price = 100,
                                         UnitsInStock = 4
                                     };
            Product superCar = Product.CreateProduct(Guid.NewGuid(), "Super Car", 2400000, 2);

            db.Products.AddObject(superCar);
            db.Products.AddObject(superWatch);

            db.SaveChanges();
        }

        private static void ListData(UniversalExportsContext db)
        {
            foreach (var product in db.Products)
            {
                Console.WriteLine("{0}, {1}, {2}", product.Name, product.Price, product.UnitsInStock);
            }
        }
    }
}
