﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PV178.Lecture8.Demo1
{
    class InsertDataDemo2
    {
        public static void Run()
        {
            InsertData();

            ListData();
        }

        private static void InsertData()
        {
            using (var db = new UniversalExportsContext(Program.GetConnectionString()))
            {
                Product watch = Product.CreateProduct(Guid.NewGuid(), "Spy Super Watch", 100, 4);
                Product car = Product.CreateProduct(Guid.NewGuid(), "Super Car", 2400000, 2);

                db.Products.AddObject(watch);
                db.Products.AddObject(car);

                Order order = new Order
                                  {
                                      Id = Guid.NewGuid(),
                                      CustomerName = "James Bond",
                                      DeliveryAddress = new Address() { Street = "Unknown", City = "London", Coutry = "UK" }
                                  };

                OrderItem item = new OrderItem
                                     {
                                         Id = Guid.NewGuid(),
                                         Product = car,
                                         Amount = 1
                                     };
                OrderItem item2 = new OrderItem
                                     {
                                         Id = Guid.NewGuid(),
                                         Product = watch,
                                         Amount = 2
                                     };

                order.Items.Add(item);
                order.Items.Add(item2);

                db.Orders.AddObject(order);

                db.SaveChanges();
            }
        }

        private static void ListData()
        {
            using (var db = new UniversalExportsContext(Program.GetConnectionString()))
            {
                foreach (var product in db.Products)
                {
                    Console.WriteLine("{0}, {1}, {2}", product.Name, product.Price, product.UnitsInStock);
                }

                Console.WriteLine();

                // pokud není zapnutý lazy loading: 1. moznost
                //foreach (var order in db.Orders.Include("Items"))
                foreach (var order in db.Orders)
                {
                    Console.WriteLine("Order for {0} ({1}, {2})", order.CustomerName, order.DeliveryAddress.City, order.DeliveryAddress.Coutry);

                    // pokud není zapnutý lazy loading: 2. moznost
                    //order.Items.Load();
                    Console.WriteLine("  Is Items collection of order loaded? {0}", order.Items.IsLoaded);

                    foreach (var item in order.Items)
                    {
                        Console.WriteLine("- {0} x {1}", item.Product.Name, item.Amount);
                    }
                }
            }
        }
    }
}
